#version 450
 
struct PerFrameUniforms
{
    mat4 gViewMat4;
    mat4 gViewProjectionMat4;
    mat4 gCameraMat4;
    mat4 gCameraNoHeadTrackingMat4;
    mat4 gPrevViewProjectionMat4;
    mat4 gThisToPrevViewProjectionMat4;
    mat4 gInverseViewMat4;
    mat4 gInverseProjectionMat4;
    mat4 gInverseProjectionSCMat4;
    mat4 gInverseViewProjectionMat4;
    vec4 gInverseWorldUpMatVec4[3];
    vec3 gViewPositionVec3;
    float gfTime;
    vec3 gVREyeInfoVec3;
    float gfPrevTime;
    vec4 gClipPlanesVec4;
    vec4 gMBlurSettingsVec4;
    vec3 gDeJitterVec3;
    int giFrameIndex;
    vec4 gTaaSettingsVec4;
    vec4 gTessSettingsVec4;
    vec4 gShellsSettingsVec4;
    vec4 gFrameBufferSizeVec4;
    vec4 gFoVValuesVec4;
    vec4 gShadowSizeVec4;
    vec3 gShadowProjScaleVec3;
    int giDisableAmbientAllowed;
    vec4 gShadowFadeParamVec4;
};

struct CommonPerMeshUniforms
{
    vec4 gPlanetPositionVec4;
    mat4 gWorldMat4;
    mat4 gWorldNormalMat4;
    float gfFadeValue;
    vec4 gLightColourVec4;
    vec4 gLightCustomParamsVec4;
    mat4 gWorldMotionMat4;
    mat4 gInverseModelMat4;
};

struct CustomPerMaterialUniforms
{
    vec4 gImposterDataVec4;
    vec4 gTileBlendScalesVec4;
    vec4 gHueOverlayParamsVec4;
    vec4 gSaturationOverlayParamsVec4;
    vec4 gValueOverlayParamsVec4;
    vec4 gTerrainColour1Vec4;
    vec4 gTerrainColour2Vec4;
    vec4 gMaterialParamsVec4;
    vec4 gMaterialColourVec4;
    vec4 gMaterialSFXVec4;
    vec4 gMaterialSFXColVec4;
    vec4 gSunPositionVec4;
};

struct CustomPerMeshUniforms
{
    vec4 gUVScrollStepVec4;
    vec4 gCustomParams01Vec4;
    vec4 gCustomParams02Vec4;
    vec4 gObjectColourVec4;
};

struct UniformBuffer
{
    PerFrameUniforms mpPerFrame;
    CommonPerMeshUniforms mpCommonPerMesh;
    CustomPerMaterialUniforms mpCustomPerMaterial;
    CustomPerMeshUniforms mpCustomPerMesh;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
layout(set = 0, binding = 45, std140) uniform Vk3DParams
{
    vec4 stereo;
    vec4 custom_params;
} vk3d_params;

layout(set = 0, binding = 0, std140) uniform lUniforms_BLK
{
    UniformBuffer lUniforms;
} _502;

layout(set = 1, binding = 2) uniform sampler2D gFadeNoiseMap;
layout(set = 1, binding = 3) uniform sampler2D gBufferMap;
layout(set = 1, binding = 0) uniform sampler2D gDiffuseMap;
layout(set = 1, binding = 1) uniform sampler2D gMasksMap;

layout(location = 0) in VertexBlock
{
    vec4 mTexCoordsVec4;
    vec4 mWorldPositionVec3_mfSpare;
    vec3 mTangentSpaceNormalVec3;
    vec4 mScreenSpacePositionVec4;
    flat vec3 mfFadeValueForInstance_mfLodIndex_mfShearMotionLength;
} In;

layout(location = 0) out vec4 out_color0;
layout(location = 1) out vec4 out_color1;
layout(location = 2) out vec4 out_color2;
layout(location = 3) out vec4 out_color3;

vec4 _1293;

void main()
{
    if (In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x < 1.0)
    {
        vec3 _901 = floor(In.mWorldPositionVec3_mfSpare.xyz);
        vec3 _903 = fract(In.mWorldPositionVec3_mfSpare.xyz);
        vec4 _923 = textureLod(gFadeNoiseMap, (_901.xy + (vec2(37.0, 17.0) * _901.z)) + ((_903 * _903) * (vec3(3.0) - (_903 * 2.0))).xy, 0.0);
        float _924 = _923.x;
        if (In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x < 0.0)
        {
            if ((1.0 - _924) > (In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x + 2.0))
            {
                discard;
            }
        }
        else
        {
            if (_924 > In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x)
            {
                discard;
            }
        }
    }
    vec2 _965 = ((In.mScreenSpacePositionVec4.xy / vec2(In.mScreenSpacePositionVec4.w)) * 0.5) + vec2(0.5);
    vec2 _1068 = (_965 * 2.0) - vec2(1.0);
    vec4 _1257 = vec4(_1068.x, _1068.y, _1293.z, _1293.w);
    _1257.z = (((_502.lUniforms.mpPerFrame.gClipPlanesVec4.x * _502.lUniforms.mpPerFrame.gClipPlanesVec4.y) / (texture(gBufferMap, vec2(_965.x, 1.0 - _965.y)).x * _502.lUniforms.mpPerFrame.gClipPlanesVec4.y)) - _502.lUniforms.mpPerFrame.gClipPlanesVec4.x) / (_502.lUniforms.mpPerFrame.gClipPlanesVec4.y - _502.lUniforms.mpPerFrame.gClipPlanesVec4.x);

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
_1257.x -= vk3d_params.stereo.x * (1 - vk3d_params.stereo.y * _1257.z * 10); 
    vec4 _1259 = _1257;
    _1259.w = 1.0;
    vec4 _1078 = _502.lUniforms.mpPerFrame.gInverseViewProjectionMat4 * _1259;
    vec3 _994 = (_502.lUniforms.mpCommonPerMesh.gInverseModelMat4 * vec4((_1078.xyz / vec3(_1078.w)).xyz + _502.lUniforms.mpPerFrame.gViewPositionVec3, 1.0)).xyz + vec3(0.5);
    float _997 = 1.0 - _994.y;
    vec3 _1263 = _994;
    _1263.y = _997;
    float _1000 = _994.x;
    bool _1001 = _1000 < 0.0;
    bool _1008;
    if (!_1001)
    {
        _1008 = _1000 >= 1.0;
    }
    else
    {
        _1008 = _1001;
    }
    bool _1015;
    if (!_1008)
    {
        _1015 = _997 < 0.0;
    }
    else
    {
        _1015 = _1008;
    }
    bool _1022;
    if (!_1015)
    {
        _1022 = _997 >= 1.0;
    }
    else
    {
        _1022 = _1015;
    }
    bool _1029;
    if (!_1022)
    {
        _1029 = _994.z < 0.0;
    }
    else
    {
        _1029 = _1022;
    }
    bool _1036;
    if (!_1029)
    {
        _1036 = _994.z >= 1.0;
    }
    else
    {
        _1036 = _1029;
    }
    if (_1036)
    {
        discard;
    }
    vec4 _624 = texture(gDiffuseMap, _1263.xy);
    vec4 _630 = texture(gMasksMap, _1263.xy);
    float _636 = _624.w * _502.lUniforms.mpCustomPerMaterial.gMaterialColourVec4.w;
    if (_636 < 9.9999997473787516355514526367188e-05)
    {
        discard;
    }
    vec4 _1278 = _1293;
    _1278.x = 0.0;
    vec4 _1280 = _1278;
    _1280.y = sqrt(((1.0 - _630.y) * _502.lUniforms.mpCustomPerMaterial.gMaterialParamsVec4.x) * 0.5);
    vec4 _1282 = _1280;
    _1282.z = clamp(_502.lUniforms.mpCustomPerMaterial.gMaterialParamsVec4.z, 0.0, 1.0);
    vec4 _1284 = _1282;
    _1284.w = 0.0;
    out_color0 = vec4(_624.xyz, _636);
    out_color1 = vec4(0.0);
    out_color2 = vec4(0.0);
    out_color3 = _1284;
}


